//-----------------------------------------------------------------------------
// opensource_notifier.m
//
// Add a Winamp Modern-esque notifier to your skin, with prefrences and all that
//
// by iPlayTheSpoons (Jared Kole)
//
// please leave this part when you distribute your skin
//-----------------------------------------------------------------------------

#include "../../../lib/std.mi"

Function Go(Float Fadein,Float Fadeout);
function SetSize();
Function SetInfo();
Function Prep();

Global Container Noti, Prefs;
Global Layout Notifier,NotifierSize;
Global Group Texts;
Global Text Artist, Song, Album, PlEntry;
Global Text FadeinText,StayText,FadeoutText;
Global Slider FadeinSlider, StaySlider, FadeoutSlider, ShadowSlider;
Global CheckBox FadeEffect, SlideEffect, Fullscreen, CDCover;
Global GUIObject Shadow;
Global Browser PhysicalCover;
Global Timer Stay, Buffer;
Global Int Tracker, ShadowOpacity, TitleW, Wide;
Global Float Fadein, Fadeout, StayTime;
Global String Effect;

System.onScriptLoaded() { 

	Noti = system.getContainer("opensource_notifier");
	Prefs = system.getContainer("opensource_notifier_prefs");
	
	Notifier = Noti.getLayout("normal");
	NotifierSize = Noti.getLayout("normal");
	PhysicalCover = Notifier.findObject("browser.cdcover");
	Texts = Notifier.findObject("notifier.text");
	
	Artist = Notifier.findObject("artist");
	Song = Notifier.findObject("title");
	Album = Notifier.findObject("album");
	PlEntry = Notifier.findObject("plentry");
	Shadow = Notifier.findObject("shadow");
	
	Layout PrefsLayout = Prefs.getLayout("normal");
	
	FadeinText = PrefsLayout.findObject("fadein.text");
	StayText = PrefsLayout.findObject("stay.text");
	FadeoutText = PrefsLayout.findObject("fadeout.text");
	FadeinSlider = PrefsLayout.findObject("fadein.slider");
	StaySlider = PrefsLayout.findObject("stay.slider");
	FadeoutSlider = PrefsLayout.findObject("fadeout.slider");
	ShadowSlider = PrefsLayout.findObject("shadow.slider");
	Fullscreen = PrefsLayout.findObject("fullscreen");
	FadeEffect = PrefsLayout.findObject("radio.fade");
	SlideEffect = PrefsLayout.findObject("radio.slide");
	CDCover = PrefsLayout.findObject("cover");
		
	Fadein = system.getPrivateInt("OpenNote","FadeIn",6);
	Fadeout = system.getPrivateInt("OpenNote","FadeOut",2);
	StayTime = system.getPrivateInt("OpenNote","Stay",16);
	ShadowOpacity = system.getPrivateInt("OpenNote","Shadow",255);
	Effect = system.getPrivateString("OpenNote","Effect","Fade");
	
	if(Effect == "Fade")
		FadeEffect.setChecked(1);
	Else
		SlideEffect.setChecked(1);
	
	Stay = new Timer;
	Buffer = new Timer;
	Buffer.setDelay(100);
	
	FadeinSlider.SetPosition(Fadein);
	FadeoutSlider.SetPosition(Fadeout);
	StaySlider.SetPosition(StayTime);
	ShadowSlider.setPosition(ShadowOpacity);
	Fullscreen.setChecked(system.getPrivateInt("OpenNote","Fullscreen",0));
	CDCover.setChecked(system.getPrivateInt("OpenNote","Cover",0));
	Notifier.hide();
	
	SetSize();
	
}

system.onScriptUnloading()
{
	system.setPrivateInt("OpenNote","FadeIn",(Fadein*4));
	system.setPrivateInt("OpenNote","FadeOut",(Fadeout*4));
	system.setPrivateInt("OpenNote","Stay",((StayTime*4)/1000));
	system.setPrivateInt("OpenNote","Shadow",ShadowOpacity);
	system.setPrivateString("OpenNote","Effect",Effect);
	system.setPrivateInt("OpenNote","Cover",CDCover.isChecked());
}

Fullscreen.onToggle(int newstate)
{
	system.setPrivateInt("OpenNote","Fullscreen",newstate);
}

FadeEffect.onToggle(int newstate)
{
	if(FadeEffect.isChecked() == 1)
	{
		Effect = "Fade";
		FadeinSlider.SetPosition(Fadein*4);
		FadeoutSlider.SetPosition(Fadeout*4);
		StaySlider.setPosition((StayTime*4)/1000);
	}
}

SlideEffect.onToggle(int newstate)
{
	if(SlideEffect.isChecked() == 1)
	{
		Effect = "Slide";
		FadeinSlider.SetPosition(Fadein*4);
		FadeoutSlider.SetPosition(Fadeout*4);
		StaySlider.setPosition((StayTime*4)/1000);
		if(Tracker == 2) 	Notifier.setXMLParam("y",integertostring(system.getViewportHeight()+5));
	}
}

ShadowSlider.onSetPosition(int newShadow)
{
	Shadow.setAlpha(newShadow);
	ShadowOpacity = newShadow;
}

FadeinSlider.onSetPosition(int newFadein)
{
	FadeinText.setText(Effect+"-in Time (" + system.floattostring(NewFadein/4,1) + "s):");
	Fadein=NewFadein/4;
}

FadeoutSlider.onSetPosition(int newFadeout)
{
	FadeoutText.setText(Effect+"-out Time (" + system.floattostring(NewFadeout/4,1) + "s):");
	Fadeout=NewFadeout/4;
}

StaySlider.onSetPosition(int newStay)
{
	StayText.setText("Hold Time (" + system.floattostring(NewStay/4,1) + "s):");
	StayTime = (newStay/4)*1000; 
	Stay.setdelay(StayTime);
}

system.onTitleChange(String NewTitle)
{
	Buffer.start();
}

system.onPlay()
{
	Buffer.start();
}

system.onResume()
{
	Buffer.start();
}

Buffer.onTimer()
{
	Buffer.stop();
	prep();
}

Notifier.onLeftButtonDown(int x, int y)
{
	Prefs.show();
}

Notifier.onRightButtonDown(int x, int y)
{
	Notifier.hide();
}

Prep()
{
	string freq=system.getPrivateString("OpenNote","Freq","Always Show Notifications");
	if((Fullscreen.isChecked() == 1 && System.isVideoFullscreen() == 0) || Fullscreen.isChecked() == 0){
	if (freq=="Always Show Notifications")
	{
		SetInfo();
		SetSize();
		Go(Fadein, FadeOut);
	}
	if (freq=="Show Notifications When Minimized" && System.isMinimized()==1)
	{
		SetInfo();
		SetSize();
		Go(Fadein, FadeOut);
	}}
}
		

SetInfo()
{	
	String PLTot = integertostring(System.getPlaylistLength());
	String PLCur = integertostring(System.getPlaylistIndex()+1);
	
	Int T = System.getPlayItemLength()/1000;
	Int M = T/60;
	Int S = T-(M*60);
	String Ss;
	if (S<10)
	{
		Ss = "0" + integertoString(S);
	}
	else
	{
		Ss = integertoString(S);
	}
		
	If (T != 0)
	{
		String Ts = integertoString(M) + ":" + Ss;
		Song.setText(system.getPlayItemMetaDataString("title") + " (" + Ts + ")");
	}
	else
		Song.setText(system.getPlayItemMetaDataString("title"));
		
	Artist.setText(system.getPlayItemMetaDataString("artist"));
	if(system.getPlayItemMetaDataString("track") > "0")
		Album.setText(system.getPlayItemMetaDataString("album") + " (Track " + system.getPlayItemMetaDataString("track") + ")");
	else
		Album.setText(system.getPlayItemMetaDataString("album"));
	PLEntry.setText(PlCur + "/" + PLTot);
}

SetSize()
{
	Int ScreenW = system.getViewPortWidth();
	Int ScreenH = system.getViewportHeight();
	Int TitleW = System.strlen(Song.getText());
		
	if(TitleW<=30)	
		Wide = 210;
	if(TitleW>30 && TitleW<45)
		Wide = 210 + (7*(TitleW-30));
	if(TitleW>=45)
		Wide = 320;
	
//	Wide = 275;

	if(CDCover.isChecked() == 1)
	{
		Wide = Wide + 70;
		PhysicalCover.show();
		Texts.setXMLParam("x","70");
		Texts.setXMLParam("w","-70");
	}
	else
	{
		PhysicalCover.hide();
		Texts.setXMLParam("x","0");
		Texts.setXMLParam("w","-0");
	}
		
	Notifier.setXMLParam("x",integertostring(ScreenW-Wide));
	if(FadeEffect.isChecked() == 1) Notifier.setXMLParam("y",integertostring(ScreenH-85));
	else Notifier.setXMLParam("y",integertostring(ScreenH+5));
	Notifier.setXMLParam("h",integertostring(80));
	Notifier.setXMLParam("w",integertostring(Wide));

}

Go(Float Fadein,Float Fadeout)
{
	Tracker = 1;
	if(FadeEffect.isChecked() == 1)
	{
		Notifier.show();
		Notifier.setTargetA(255);
		Notifier.setTargetY(system.getViewportHeight()-85);
		Notifier.SetTargetW(Wide);
		Notifier.setTargetX(system.getViewportWidth()-Wide);
		Notifier.setTargetSpeed(Fadein);
		Notifier.gotoTarget();
	}
	else
	{
		Notifier.setAlpha(255);
		Notifier.show();
		Notifier.setTargetA(255);
		Notifier.setTargetY(system.getViewportHeight()-85);
		Notifier.SetTargetW(Wide);
		Notifier.setTargetX(system.getViewportWidth()-Wide);
		Notifier.setTargetSpeed(Fadein);
		Notifier.gotoTarget();
	}
}

Notifier.onTargetReached()
{
	if (Tracker == 1)
	{
		Stay.start();
	}
	if (Tracker == 2)
	{
		Notifier.hide();
	}
}
	
Stay.onTimer()
{
	Stay.stop();
	Tracker = 2;
	if(FadeEffect.isChecked() == 1)
	{
		Notifier.setTargetA(0);
		Notifier.setTargetY(system.getViewportHeight()-85);
		Notifier.SetTargetW(Wide);
		Notifier.setTargetX(system.getViewportWidth()-Wide);
		Notifier.setTargetSpeed(Fadeout);
		Notifier.gotoTarget();
	}
	else
	{
		Notifier.show();
		Notifier.setTargetA(255);
		Notifier.setTargetY(system.getViewportHeight()+5);
		Notifier.SetTargetW(Wide);
		Notifier.setTargetX(system.getViewportWidth()-Wide);
		Notifier.setTargetSpeed(Fadein);
		Notifier.gotoTarget();
	}

}


	