//----------------------------------------------------------------------
//    lcd.m
//
//    controls whatever stuff is in the LCD
//    
//----------------------------------------------------------------------

#include "../../../lib/std.mi"

Function UpdateTickers(int intSelection);

Global Container MainContainer,Pledit;
Global Layout NormalLayout,PleditStick;
Global Text Ticker,StickTicker1,StickTicker2;
Global PopupMenu TickPop;

System.onScriptLoaded() {
  	MainContainer = getContainer("main");
  	Pledit = getContainer("pledit");
    NormalLayout = MainContainer.getLayout("normal");
    PleditStick = Pledit.getLayout("stick");  
	
	Ticker = NormalLayout.findObject("SongTicker");
	StickTicker1 = PleditStick.findObject("SongTicker1");
	StickTicker2 = PleditStick.findObject("SongTicker2");
		
	TickPop = new PopupMenu;
		TickPop.addCommand(" Enable Song Ticker Scrolling", 1, 0, 0);
		TickPop.addCommand(" Disable Song Ticker Scrolling", 2, 0, 0);
		
	Ticker.setXmlParam("ticker", System.integerToString(System.getPrivateInt("Classix10k", "Ticker", 1)));
	StickTicker1.setXmlParam("ticker", System.integerToString(System.getPrivateInt("Classix10k", "Ticker", 1)));
	StickTicker2.setXmlParam("ticker", System.integerToString(System.getPrivateInt("Classix10k", "Ticker", 1)));

}

System.onScriptUnloading() {
	Delete TickPop;
}

Ticker.onRightButtonDown(int x, int y) {
	Int intSelection = TickPop.popAtMouse();
		if (intSelection > 0) {
			UpdateTickers(intSelection);
	}
	Complete;
}

StickTicker1.onRightButtonDown(int x, int y) {
	Int intSelection = TickPop.popAtMouse();
		if (intSelection > 0) {
			UpdateTickers(intSelection);
	}
	Complete;
}

StickTicker2.onRightButtonDown(int x, int y) {
	Int intSelection = TickPop.popAtMouse();
		if (intSelection > 0) {
			UpdateTickers(intSelection);
	}
	Complete;
}

UpdateTickers(int intSelection)
{
	if (intSelection==1) {
	Ticker.setXmlParam("ticker", System.integerToString(1));
	Ticker.setXmlParam("tooltip", "Right Click for Scroll Setting // Enabled");
	StickTicker1.setXmlParam("ticker", System.integerToString(1));
	StickTicker1.setXmlParam("tooltip", "Right Click for Scroll Setting // Enabled");
	StickTicker2.setXmlParam("ticker", System.integerToString(1));
	StickTicker2.setXmlParam("tooltip", "Right Click for Scroll Setting // Enabled");
	System.setPrivateInt("Classix10k", "Ticker", 1);
	} 
	else if (intSelection==2) {
	Ticker.setXmlParam("ticker", System.integerToString(0));
	Ticker.setXmlParam("tooltip", "Right Click for Scroll Setting // Disabled");
	StickTicker1.setXmlParam("ticker", System.integerToString(0));
	StickTicker1.setXmlParam("tooltip", "Right Click for Scroll Setting // Disabled");
	StickTicker2.setXmlParam("ticker", System.integerToString(0));
	StickTicker2.setXmlParam("tooltip", "Right Click for Scroll Setting // Disabled");
	System.setPrivateInt("Classix10k", "Ticker", 0);
	}
}